package com.hzya.frame.sysnew.integtationTaskLivingDetails.service.impl;

import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.sysnew.integtationTaskLivingDetails.entity.IntegrationTaskLivingDetailsEntity;
import com.hzya.frame.sysnew.integtationTaskLivingDetails.dao.IIntegrationTaskLivingDetailsDao;
import com.hzya.frame.sysnew.integtationTaskLivingDetails.service.IIntegrationTaskLivingDetailsService;
import com.hzya.frame.sysnew.integtationTaskLog.entity.IntegrationTaskLogEntity;
import com.hzya.frame.uuid.UUIDLong;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import com.hzya.frame.web.exception.BaseSystemException;
import org.springframework.stereotype.Service;
import org.springframework.beans.factory.annotation.Autowired;
import javax.annotation.Resource;
import com.hzya.frame.basedao.service.impl.BaseService;
/**
 * 集成任务-实例详情(IntegrationTaskLivingDetails)表服务实现类
 *
 * @author makejava
 * @since 2024-05-15 14:06:46
 */
@Service(value = "integrationTaskLivingDetailsService")
public class IntegrationTaskLivingDetailsServiceImpl extends BaseService<IntegrationTaskLivingDetailsEntity, String> implements IIntegrationTaskLivingDetailsService {

    private IIntegrationTaskLivingDetailsDao integrationTaskLivingDetailsDao;

    @Autowired
	public void setIntegrationTaskLivingDetailsDao(IIntegrationTaskLivingDetailsDao dao) {
		this.integrationTaskLivingDetailsDao = dao;
		this.dao = dao;
	}
/**
 *
 * @content 完全用于测试，此接口不使用1
 * @author laborer
 * @date 2024/5/15 0015 16:00
 *
 */

    @Override
    public JsonResultEntity testLog(JSONObject jsonObject)throws Exception {
        IntegrationTaskLivingDetailsEntity entity = getData("jsonStr", jsonObject, IntegrationTaskLivingDetailsEntity.class);
        String def1 = entity.getDef1();
        switch (def1){
            case "1":
                return saveLogToSuccess(entity);
            case "2":
                return saveLogToFail(entity);
            case "3":
                return saveLogFailToSuccess(entity);
            case "4":
                return updateLogFailToSuccess(entity);
            default:
                break;
        }
        return null;
    }

    /**
     *
     * @content 成功日志公用接口
     * @author laborer
     * @date 2024/5/15 0015 15:05
     *
     */
    @Override
    public JsonResultEntity saveLogToSuccess(IntegrationTaskLivingDetailsEntity entity)throws Exception {
        entity.setId(String.valueOf(UUIDLong.longUUID()));
        checkDate(entity);
        entity.setNewState("Y");
        entity.setRepairPust("N");
        try {
            entity = integrationTaskLivingDetailsDao.saveSuccessLog(entity);
            return BaseResult.getSuccessMessageEntity(entity);
        } catch (Exception e) {
            e.printStackTrace();
            return BaseResult.getFailureMessageEntity("保存成功日志失败："+e.getMessage());
        }

    }


    /**
     *
     * @content 失败日志公用接口
     * @author laborer
     * @date 2024/5/15 0015 15:05
     *
     */
    @Override
    public JsonResultEntity saveLogToFail(IntegrationTaskLivingDetailsEntity entity)throws Exception {
        entity.setId(String.valueOf(UUIDLong.longUUID()));
        //验证必填字段如果不满足返回数据
        checkDate(entity);
        entity.setNewState("N");
        entity.setRepairPust("Y");
        try {
            entity = integrationTaskLivingDetailsDao.save(entity);
            return BaseResult.getSuccessMessageEntity(entity);
        } catch (Exception e) {
            e.printStackTrace();
            return BaseResult.getFailureMessageEntity("保存失败日志错误："+e.getMessage());
        }
    }
    /**
     *
     * @content 重推成功接口(成功数据挪到成功日志表)
     * @author laborer
     * @date 2024/5/15 0015 15:05
     *
     */
    @Override
    public JsonResultEntity saveLogFailToSuccess(IntegrationTaskLivingDetailsEntity entity)throws Exception {
        //验证必填字段如果不满足返回数据
        checkDate(entity);
        entity.setNewState("Y");
        entity.setRepairPust("N");
        try {
            //先根据主键删除错误日志表数据，在进行成功表写入
            integrationTaskLivingDetailsDao.delete(entity.getId());
            //将数据写入成功日志表
            entity = integrationTaskLivingDetailsDao.saveSuccessLog(entity);
            return BaseResult.getSuccessMessageEntity(entity);
        } catch (Exception e) {
            e.printStackTrace();
            return BaseResult.getFailureMessageEntity("保存失败日志错误："+e.getMessage());
        }
    }
    /**
     *
     * @content 重推失败更新接口
     * @author laborer
     * @date 2024/5/15 0015 15:05
     *
     */
    @Override
    public JsonResultEntity updateLogFailToSuccess(IntegrationTaskLivingDetailsEntity entity)throws Exception {
        //验证必填字段如果不满足返回数据
        checkDate(entity);
        entity.setNewState("N");
        entity.setRepairPust("Y");
        try {
            //将数据写入成功日志表
            entity = integrationTaskLivingDetailsDao.update(entity);
            return BaseResult.getSuccessMessageEntity(entity);
        } catch (Exception e) {
            e.printStackTrace();
            return BaseResult.getFailureMessageEntity("更新失败日志错误："+e.getMessage());
        }
    }
    /**
     *
     * @content 验证数据必填项
     * @author laborer
     * @date 2024/5/15 0015 15:42
     *
     */

    private void checkDate(IntegrationTaskLivingDetailsEntity entity)throws Exception{
        //todo 除了必填字段理论都可以为空 根据业务需求自己定义
        //验证必填字段如果不满足返回数据
        String id = entity.getId();//不可为空，数据主键
        if (StrUtil.isEmpty(id)) {
            throw new BaseSystemException("主键不可为空，请传入");
        }
        String rootAppPk = entity.getRootAppPk();//源系统主键（通过该条件进行重推时数据查询不可为空）
        if (StrUtil.isEmpty(rootAppPk)) {
            throw new BaseSystemException("源系统主键不可为空，请传入");
        }
        String rootAppBill = entity.getRootAppBill();//源系统单号（通过该条件进行重查询条件不可为空）
        if (StrUtil.isEmpty(rootAppBill)) {
            throw new BaseSystemException("源系统单号不可为空，请传入");
        }
        String pluginId = entity.getPluginId();//插件ID 用于任务寻找插件方法字段（不可为空）
        if (StrUtil.isEmpty(pluginId)) {
            throw new BaseSystemException("插件ID不可为空，请传入");
        }
        String rootAppNewData = entity.getRootAppNewData();//推送数据-最新（不可为空）
        if (StrUtil.isEmpty(rootAppNewData)) {
            throw new BaseSystemException("推送数据-最新不可为空，请传入");
        }
        String newTransmitInfo = entity.getNewTransmitInfo();//三方系统返回数据（不可为空）
        if (StrUtil.isEmpty(newTransmitInfo)) {
            throw new BaseSystemException("三方系统返回数据不可为空，请传入");
        }
//        String repairPust = entity.getRepairPust();//是否补推(Y是N不是) 成功情况下默认N不需要补退
//        if (StrUtil.isEmpty(repairPust)) {
//            throw new BaseSystemException("是否补推不可为空，请传入");
//        }
//        String newState = entity.getNewState();//推送状态 成功情况下默认Y
//        if (StrUtil.isEmpty(newState)) {
//            throw new BaseSystemException("推送状态不可为空，请传入");
//        }
    }

}
